//        OpenCV DLL
//
//      Modified by:  J Blahnik
//    Sample OpenCV Win32 program
//           May, 2007
//
//**********************************

#include "cv.h"
#include "cvcam.h"
#include "highgui.h"
#include <stdio.h>
#include <windows.h>


//#define ID_START_BUTTON 200
//#define ID_EXIT_BUTTON  201


int stopCamFeed();
int startCamFeed();
//LRESULT CALLBACK MyWndProc(HWND, UINT, WPARAM, LPARAM);


//---- Win32 Globals ----
//LPSTR szClassName = "MyClass";
//HINSTANCE hInstance;
//HWND hwnd, hwndStartButton, hwndExitButton;


//---- OpenCV Globals ----
IplImage *frame = 0;
CvCapture* capture = 0;


int _stdcall jfbFred() {
	return 12;
}




void _stdcall jfbStopCamFeed() {
    
	cvReleaseCapture( &capture );
    cvDestroyWindow("Cam Feed");
	
	//SetWindowText(hwndStartButton,"Start Cam");
	
}




int _stdcall jfbInitCam(int cam) {

	capture = cvCaptureFromCAM(cam);  // 0

    if( !capture ) return(0);

//    cvNamedWindow( "Cam Feed", CV_WINDOW_AUTOSIZE);

	return 1;
}




int _stdcall jfbGetImage() {

   frame = cvQueryFrame( capture );

   if( !frame ) return 0;

   return 1;
}





char * _stdcall jfbGetImageDataPtr() {

   frame = cvQueryFrame( capture );

   if( !frame ) return 0;

   return frame->imageData;
}




void _stdcall jfbShowImage() {
   cvShowImage("Cam Feed", frame);
}










/*
int startCamFeed() {
    int k;
	CvPoint pp = {20,20};


	SetWindowText(hwndStartButton,"Stop Cam");

    //capture = cvCaptureFromFile("record.avi");
	capture = cvCaptureFromCAM(0);

    if( !capture ) return(-1);

    cvNamedWindow( "Cam Feed", CV_WINDOW_AUTOSIZE);


	//   Capture then Show Image Loop
    while(1) {

        frame = cvQueryFrame( capture );

        if( !frame ) break;


	    int bb =  frame->height; //frame->width; //cvGetSize(frame);
	    bb = frame->imageSize;  //  width * height   verified!!
	    //bb = frame -> nSize;  // size of IplImage struct
        char dd[80];
	    itoa(bb,dd,10);

        CvFont font;
        cvInitFont(&font, CV_FONT_HERSHEY_SIMPLEX, 1.3, 1.3, 0, 1, CV_AA);

	    cvPutText(frame, dd, pp, &font, cvScalar(255,255,255,0));



	    //   add some pixels to show (assuming 320 x 240)
	    int rowoff1 = 320*3*52;  // row 52
	    int rowoff2 = 320*3*22;  // row 22
	
	    for(k=0; k<320*3; k=k+3) {
		   frame->imageData[k+rowoff1+0] = 0;    // blue
		   frame->imageData[k+rowoff1+1] = 0;
		   frame->imageData[k+rowoff1+2] = 255;  // red

           frame->imageData[k+rowoff2+0] = 0;    // blue
		   frame->imageData[k+rowoff2+1] = 255;
		   frame->imageData[k+rowoff2+2] = 0;    // red
		}



		cvShowImage("Cam Feed", frame);

        int c = cvWaitKey(10);
        if( (char)c == 27 ) break;
    }

	stopCamFeed();
    return 0;
}

*/



/*
int stopCamFeed() {
    
	cvReleaseCapture( &capture );
    cvDestroyWindow("Cam Feed");
	
	SetWindowText(hwndStartButton,"Start Cam");
	
	return 0;
}

*/




//*********************************************************************************************/
//*********************************************************************************************/
//*********************************************************************************************/
//*********************************************************************************************/
//*********************************************************************************************/



/*
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR szCmdLine, int iCmdShow) {
   WNDCLASS wnd;
   MSG msg;

   hInstance = hInst;
        
   wnd.style		 = CS_HREDRAW | CS_VREDRAW;			//we will explain this later
   wnd.lpfnWndProc	 = MyWndProc;
   wnd.cbClsExtra	 = 0;
   wnd.cbWndExtra	 = 0;
   wnd.hInstance	 = hInstance;
   wnd.hIcon		 = LoadIcon(NULL, IDI_APPLICATION); //default icon
   wnd.hCursor		 = LoadCursor(NULL, IDC_ARROW);		//default arrow mouse cursor
   wnd.hbrBackground = (HBRUSH)(COLOR_BACKGROUND+1);
   wnd.lpszMenuName  = NULL;							//no menu
   wnd.lpszClassName = szClassName;

   if(!RegisterClass(&wnd)) {                     //register the WNDCLASS
       MessageBox(NULL, "This Program Requires Windows NT", "Error", MB_OK);
       return 0;
   }

   wnd.style		  = CS_OWNDC | CS_VREDRAW | CS_HREDRAW;
   wnd.lpfnWndProc   = MyWndProc;
   wnd.cbClsExtra    = 0;
   wnd.cbWndExtra    = 0;
   wnd.hInstance	  = hInstance;
   wnd.lpszClassName = "image frame";
   wnd.lpszMenuName  = "image frame";
   wnd.hIcon		  = LoadIcon(0, IDI_APPLICATION);
   wnd.hCursor		  = (HCURSOR)LoadCursor(0, (LPSTR)(size_t)IDC_CROSS );
   wnd.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
   //wnd.hbrBackground = (HBRUSH)(COLOR_BACKGROUND+1);

   RegisterClass(&wnd);

   //-------------------- Main Window --------------------
   hwnd = CreateWindow(szClassName,
					   TEXT("Object Detection Project"),
                       WS_OVERLAPPEDWINDOW, //basic window style
                       CW_USEDEFAULT,		//horizontal position
                       CW_USEDEFAULT,       //vertical position
                       300,					//window width
                       300,					//window height
                       NULL,                //no parent window
                       NULL,                //no menu
                       hInstance,			//handle to application instance
                       NULL);               //no parameters to pass
   ShowWindow(hwnd, iCmdShow);     //display the window on the screen
   UpdateWindow(hwnd);             //make sure the window is updated correctly

   //-------------------- Start Button --------------------
   hwndStartButton = CreateWindow (TEXT("button"),           // The class name required is button
								   TEXT("Start Cam"),		 // the caption of the button
				                   WS_CHILD | BS_PUSHBUTTON, // the styles
						           20,20,                    // the left and top co-ordinates
							       100,30,                   // width and height
						   		   hwnd,                     // parent window handle
							  	   (HMENU)ID_START_BUTTON,   // the ID of my button
							       hInstance,                // the instance of your application
						  		   NULL) ;                   // extra bits you dont really need
   ShowWindow(hwndStartButton, iCmdShow);     //display the start button on the screen
   UpdateWindow(hwndStartButton);             //make sure the start button is updated correctly

   //-------------------- Exit Button --------------------
   hwndExitButton = CreateWindow (TEXT("button"),            // The class name required is button
								   TEXT("Exit"),		     // the caption of the button
				                   WS_CHILD | BS_PUSHBUTTON, // the styles
						           125,20,                   // the left and top co-ordinates
							       100,30,                   // width and height
						   		   hwnd,                     // parent window handle
							  	   (HMENU)ID_EXIT_BUTTON,    // the ID of my button
							       hInstance,                // the instance of your application
						  		   NULL) ;                   // extra bits you dont really need
   ShowWindow(hwndExitButton, iCmdShow);     //display the start button on the screen
   UpdateWindow(hwndExitButton);             //make sure the start button is updated correctly


   startCamFeed();

   while(GetMessage(&msg, NULL, 0, 0)) {      //message loop
       TranslateMessage(&msg);
       DispatchMessage(&msg);
   }
   return msg.wParam;
}




LRESULT CALLBACK MyWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
   switch(msg) {   
	   case WM_COMMAND:
			if(ID_START_BUTTON == LOWORD(wParam)) { 
				
				if(BN_CLICKED == HIWORD(wParam)) {
					
					if (cvGetWindowHandle("Cam Feed")) stopCamFeed();
					else startCamFeed();
				}
			}

			if(ID_EXIT_BUTTON == LOWORD(wParam)) { 
				stopCamFeed();
				PostQuitMessage(0);
				return 0;
			}

	   case WM_RBUTTONDOWN:
			//ShowWindow(hwnd, SW_HIDE);	//hide window
			break;
       
	   case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
   }
   return DefWindowProc(hwnd, msg, wParam, lParam);
}

*/