VERSION 5.00
Begin VB.Form frmKeyboard 
   Caption         =   "Keyboard Control"
   ClientHeight    =   3495
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4530
   ControlBox      =   0   'False
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   3495
   ScaleWidth      =   4530
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCtrl 
      AutoSize        =   -1  'True
      Height          =   735
      Left            =   240
      ScaleHeight     =   675
      ScaleWidth      =   1155
      TabIndex        =   5
      Top             =   1080
      Width           =   1215
   End
   Begin VB.PictureBox picShift 
      AutoSize        =   -1  'True
      Enabled         =   0   'False
      Height          =   735
      Left            =   240
      Picture         =   "frmKeyboard.frx":0000
      ScaleHeight     =   45
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   45
      TabIndex        =   4
      Top             =   120
      Width           =   735
   End
   Begin VB.PictureBox picUp 
      AutoSize        =   -1  'True
      Enabled         =   0   'False
      Height          =   735
      Left            =   2760
      Picture         =   "frmKeyboard.frx":0CB2
      ScaleHeight     =   45
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   45
      TabIndex        =   3
      Top             =   240
      Width           =   735
   End
   Begin VB.PictureBox picLeft 
      AutoSize        =   -1  'True
      Enabled         =   0   'False
      Height          =   735
      Left            =   1920
      Picture         =   "frmKeyboard.frx":1964
      ScaleHeight     =   45
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   45
      TabIndex        =   2
      Top             =   1080
      Width           =   735
   End
   Begin VB.PictureBox picDown 
      AutoSize        =   -1  'True
      Enabled         =   0   'False
      Height          =   735
      Left            =   2760
      Picture         =   "frmKeyboard.frx":2616
      ScaleHeight     =   45
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   45
      TabIndex        =   1
      Top             =   1080
      Width           =   735
   End
   Begin VB.PictureBox picRight 
      AutoSize        =   -1  'True
      Enabled         =   0   'False
      Height          =   735
      Left            =   3600
      Picture         =   "frmKeyboard.frx":32C8
      ScaleHeight     =   45
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   45
      TabIndex        =   0
      Top             =   1080
      Width           =   735
   End
   Begin VB.Label lblControls 
      Caption         =   "Label1"
      Height          =   1215
      Left            =   240
      TabIndex        =   6
      Top             =   2160
      Width           =   4095
   End
End
Attribute VB_Name = "frmKeyboard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *******************************************************************
'                          ROOMBACAM FRMKEYBOARD
'   This form allows the user to control the robot via the keyboard.
'       It works by trapping the select keys and calling public
'       functions from the main client form (frmClient).
' *******************************************************************

Option Explicit

Dim ImagePath As String
Dim keyLastKey As Integer



Private Sub Form_Load()

    lblControls.Caption = "CONTROLS" & vbCrLf & "==========" & vbCrLf & _
                          "Up/Down - Increment/Decrement Speed" & vbCrLf & _
                          "Left/Right - Pivot Robot" & vbCrLf & _
                          "Enter - Switch Direction" & vbCrLf & _
                          "Ctrl/Esc - Stop Robot"


'    ImagePath = "G:\PANKDC\cs460\projects\create\images\"
    ImagePath = "C:\RoombaCam\Images\"

    picRight.Picture = LoadPicture(ImagePath & "rightu.bmp")
    picDown.Picture = LoadPicture(ImagePath & "downu.bmp")
    picLeft.Picture = LoadPicture(ImagePath & "leftu.bmp")
    picUp.Picture = LoadPicture(ImagePath & "upu.bmp")
    picShift.Picture = LoadPicture(ImagePath & "enteru.bmp")
    picCtrl.Picture = LoadPicture(ImagePath & "ctrlu.bmp")

    keyLastKey = vbKey1             ' keep track of the last key pressed

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, shift As Integer)
' *******************************************************************
'   Record the key press, change the picture to depict the press
'       and call the appropriate frmClient function to translate the
'       command to JoeCode and send to the server.
' *******************************************************************
    Select Case (KeyCode)
        Case Is = vbKeyRight
            If (keyLastKey = vbKeyRight) Then
                Call frmClient.btnResume_Click
                keyLastKey = vbKey1             ' dummy key
                Exit Sub
            Else
                picRight.Picture = LoadPicture(ImagePath & "rightd.bmp")
                frmClient.radRight.Value = True
                frmClient.radPivot.Value = True
                Call frmClient.btnTurn_Click
            End If
        Case Is = vbKeyDown
            picDown.Picture = LoadPicture(ImagePath & "downd.bmp")
            frmClient.btnDown_Click
        Case Is = vbKeyLeft
            If (keyLastKey = vbKeyLeft) Then
                Call frmClient.btnResume_Click
                keyLastKey = vbKey1             ' dummy key
                Exit Sub
            Else
                picLeft.Picture = LoadPicture(ImagePath & "leftd.bmp")
                frmClient.radLeft.Value = True
                frmClient.radPivot.Value = True
                Call frmClient.btnTurn_Click
            End If
        Case Is = vbKeyUp
            picUp.Picture = LoadPicture(ImagePath & "upd.bmp")
            frmClient.btnUp_Click
        Case Is = vbKeyReturn
            picShift.Picture = LoadPicture(ImagePath & "enterd.bmp")
            Call frmClient.btnSwitch_Click
        Case Is = vbKeyControl
            picCtrl.Picture = LoadPicture(ImagePath & "ctrld.bmp")
            Call frmClient.btnStop_Click
        Case Is = vbKeyEscape
            picCtrl.Picture = LoadPicture(ImagePath & "ctrld.bmp")
            Call frmClient.btnStop_Click
    End Select

    keyLastKey = KeyCode

End Sub

Private Sub Form_KeyUp(KeyCode As Integer, shift As Integer)
' *******************************************************************
'   Reset the image to depict that the key is no longer held down
' *******************************************************************
    Select Case (KeyCode)
        Case Is = vbKeyRight
            picRight.Picture = LoadPicture(ImagePath & "rightu.bmp")
        Case Is = vbKeyDown
            picDown.Picture = LoadPicture(ImagePath & "downu.bmp")
        Case Is = vbKeyLeft
            picLeft.Picture = LoadPicture(ImagePath & "leftu.bmp")
        Case Is = vbKeyUp
            picUp.Picture = LoadPicture(ImagePath & "upu.bmp")
        Case Is = vbKeyReturn
            picShift.Picture = LoadPicture(ImagePath & "enteru.bmp")
        Case Is = vbKeyControl
            picCtrl.Picture = LoadPicture(ImagePath & "ctrlu.bmp")
        Case Is = vbKeyEscape
            picCtrl.Picture = LoadPicture(ImagePath & "ctrlu.bmp")
    End Select
    
End Sub

